=== debian/changelog ===
git-annex (5.20141024~bpo70+1) wheezy-backports; urgency=medium

  * Updated backport to version 5.20141024.

 -- Joey Hess <joeyh@debian.org>  Fri, 07 Nov 2014 13:38:01 -0400

git-annex (5.20141024) unstable; urgency=medium

  * vicfg: Deleting configurations now resets to the default, where
    before it has no effect.
  * Remove hurd stuff from cabal file, since hackage currently rejects
    it, and the test suite fails on hurd.
  * initremote: Don't allow creating a special remote that has the same
    name as an existing git remote.
  * Windows: Use haskell setenv library to clean up several ugly workarounds
    for inability to manipulate the environment on windows. This includes
    making git-annex not re-exec itself on start on windows, and making the
    test suite on Windows run tests without forking.
  * glacier: Fix pipe setup when calling glacier-cli to retrieve an object.
  * info: When run on a single annexed file, displays some info about the 
    file, including its key and size.
  * info: When passed the name or uuid of a remote, displays info about that
    remote. Remotes that support encryption, chunking, or embedded
    creds will include that in their info.
  * enableremote: When the remote has creds, update the local creds cache
    file. Before, the old version of the creds could be left there, and
    would continue to be used.

 -- Joey Hess <joeyh@debian.org>  Fri, 24 Oct 2014 13:03:29 -0400

git-annex (5.20141013) unstable; urgency=medium

  * Adjust cabal file to support building w/o assistant on the hurd.
  * Support building with yesod 1.4.
  * S3: Fix embedcreds=yes handling for the Internet Archive.
  * map: Handle .git prefixed remote repos. Closes: #614759
  * repair: Prevent auto gc from happening when fetching from a remote.

 -- Joey Hess <joeyh@debian.org>  Mon, 13 Oct 2014 10:13:06 -0400

git-annex (5.20140927~bpo70+3) wheezy-backports; urgency=medium

  * Work around bug in cabal that causes it to disable webapp flag when
    the webapp-secure flag cannot be resolved. Re-enables building the webapp
    in this backport. Closes: #763796

 -- Joey Hess <joeyh@debian.org>  Thu, 02 Oct 2014 15:22:17 -0400

git-annex (5.20140927~bpo70+2) wheezy-backports; urgency=medium

  * Drop dependency on git back down for backport. Closes: #763622

 -- Joey Hess <joeyh@debian.org>  Wed, 01 Oct 2014 11:01:17 -0400

git-annex (5.20140927~bpo70+1) wheezy-backports; urgency=high

  * Updating backport to newest release, which contains a security fix.
  * Disabled workaround for ghc bug #763078, which does not affect wheezy.

 -- Joey Hess <joeyh@debian.org>  Tue, 30 Sep 2014 13:06:56 -0400

git-annex (5.20140927) unstable; urgency=medium

  * Really depend (not just build-depend) on new enough git for --no-gpg-sign
    to work. Closes: #763057
  * Add temporary workaround for bug #763078 which broke building on armel
    and armhf.

 -- Joey Hess <joeyh@debian.org>  Sat, 27 Sep 2014 14:25:09 -0400

git-annex (5.20140926) unstable; urgency=high

  * Depend on new enough git for --no-gpg-sign to work. Closes: #762446
  * Work around failure to build on mips by using cabal, not Setup,
    to build in debian/rules.

 -- Joey Hess <joeyh@debian.org>  Fri, 26 Sep 2014 15:09:02 -0400

git-annex (5.20140919) unstable; urgency=high

  * Security fix for S3 and glacier when using embedcreds=yes with
    encryption=pubkey or encryption=hybrid. CVE-2014-6274
    The creds embedded in the git repo were *not* encrypted.
    git-annex enableremote will warn when used on a remote that has
    this problem. For details, see:
    https://git-annex.branchable.com/upgrades/insecure_embedded_creds/
  * assistant: Detect when repository has been deleted or moved, and
    automatically shut down the assistant. Closes: #761261
  * Windows: Avoid crashing trying to list gpg secret keys, for gcrypt
    which is not yet supported on Windows.
  * WebDav: Fix enableremote crash when the remote already exists.
    (Bug introduced in version 5.20140817.)
  * add: In direct mode, adding an annex symlink will check it into git,
    as was already done in indirect mode.

 -- Joey Hess <joeyh@debian.org>  Fri, 19 Sep 2014 12:53:42 -0400

git-annex (5.20140915) unstable; urgency=medium

  * New annex.hardlink setting. Closes: #758593
  * init: Automatically detect when a repository was cloned with --shared,
    and set annex.hardlink=true, as well as marking the repository as
    untrusted.
  * Fix parsing of ipv6 address in git remote address when it was not
    formatted as an url.
  * The annex-rsync-transport configuration is now also used when checking
    if a key is present on a rsync remote, and when dropping a key from
    the remote.
  * Promote file not found warning message to an error.
  * Fix transfer lock file FD leak that could occur when two separate
    git-annex processes were both working to perform the same set of
    transfers.
  * sync: Ensure that pending changes to git-annex branch are committed
    before push when in direct mode. (Fixing a very minor reversion.)
  * WORM backend: Switched to include the relative path to the file inside
    the repository, rather than just the file's base name. Note that if you're
    relying on such things to keep files separate with WORM, you should really
    be using a better backend.
  * Rather than crashing when there's a problem with the requested bloomfilter
    capacity/accuracy, fall back to a reasonable default bloom filter size.
  * Fix build with optparse-applicative 0.10. Closes: #761484
  * webapp: Fixed visual glitch in xmpp pairing that was reported live by a
    user who tracked me down in front of a coffee cart in Portland. 
    (New bug reporting method of choice?)

 -- Joey Hess <joeyh@debian.org>  Mon, 15 Sep 2014 10:45:00 -0400

git-annex (5.20140831~bpo70+1) wheezy-backports; urgency=low

  * Updating backport to newest release. Closes: #760787

 -- Joey Hess <joeyh@debian.org>  Tue, 09 Sep 2014 11:48:36 -0400


