## git-annex 5.20141125

=== debian/changelog ===
git-annex (5.20141125) unstable; urgency=medium

  * Remove fixup code for bad bare repositories created by
    versions 5.20131118 through 5.20131127. That fixup code would
    accidentially fire when --git-dir was incorrectly
    pointed at the working tree of a git-annex repository,
    possibly resulting in data loss. Closes: #768093
  * Windows: Fix crash when user.name is not set in git config.

 -- Joey Hess <joeyh@debian.org>  Wed, 05 Nov 2014 11:41:51 -0400
