=== debian/control ===
--- 
+++ 
@@ -15,6 +15,7 @@
 	libghc-dataenc-dev,
 	libghc-utf8-string-dev,
 	libghc-hs3-dev (>= 0.5.6),
+	libghc-dav-dev (>= 1.0) [amd64 i386 kfreebsd-amd64 kfreebsd-i386 powerpc],
 	libghc-quickcheck2-dev,
 	libghc-monad-control-dev (>= 0.3),
 	libghc-exceptions-dev (>= 0.6),
@@ -30,6 +31,7 @@
 	libghc-hinotify-dev [linux-any],
 	libghc-stm-dev (>= 2.3),
 	libghc-dbus-dev (>= 0.10.3) [linux-any],
+	libghc-fdo-notify-dev (>= 0.3) [linux-any],
 	libghc-yesod-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
 	libghc-yesod-static-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
 	libghc-yesod-default-dev [i386 amd64 kfreebsd-amd64 powerpc],
@@ -40,6 +42,9 @@
 	libghc-warp-tls-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
 	libghc-wai-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
 	libghc-wai-extra-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
+	libghc-securemem-dev,
+	libghc-byteable-dev,
+	libghc-dns-dev,
 	libghc-case-insensitive-dev,
 	libghc-http-types-dev,
 	libghc-http-conduit-dev,
@@ -48,21 +53,28 @@
 	libghc-network-multicast-dev,
 	libghc-network-info-dev [linux-any kfreebsd-any],
 	libghc-safesemaphore-dev,
-	libghc-network-protocol-xmpp-dev (>= 0.4.3-1),
-	libghc-gnutls-dev (>= 0.1.4-3~bpo70+1),
+	libghc-network-protocol-xmpp-dev (>= 0.4.3-1+b1),
+	libghc-gnutls-dev (>= 0.1.4),
 	libghc-xml-types-dev,
 	libghc-async-dev,
-	libghc-feed-dev,
+	libghc-feed-dev (>= 0.3.9.2),
 	libghc-regex-tdfa-dev [!mipsel !s390],
 	libghc-regex-compat-dev [mipsel s390],
+	libghc-tasty-dev (>= 0.7) [!sparc],
+	libghc-tasty-hunit-dev [!sparc],
+	libghc-tasty-quickcheck-dev [!sparc],
+	libghc-tasty-rerun-dev [!sparc],
+	libghc-optparse-applicative-dev [!sparc],
 	lsof [!kfreebsd-i386 !kfreebsd-amd64 !hurd-any],
 	ikiwiki,
 	perlmagick,
-	git (>= 1:1.8.4),
+	git (>= 1:2.0),
 	rsync,
 	wget,
 	curl,
 	openssh-client,
+	git-remote-gcrypt (>= 0.20130908-6),
+	llvm-3.4 [armel armhf],
 Maintainer: Joey Hess <joeyh@debian.org>
 Standards-Version: 3.9.5
 Vcs-Git: git://git.kitenet.net/git-annex
@@ -73,7 +85,7 @@
 Architecture: any
 Section: utils
 Depends: ${misc:Depends}, ${shlibs:Depends},
-	git (>= 1:1.8.4),
+	git (>= 1:2.0),
 	rsync,
 	wget,
 	curl,
@@ -83,7 +95,7 @@
 	gnupg,
 	bind9-host,
 	quvi,
-	git-remote-gcrypt (>= 0.20130908-6~bpo70+1),
+	git-remote-gcrypt (>= 0.20130908-6),
 	nocache,
 Suggests:
 	graphviz,
