## git-annex 5.20141125+deb8u1

=== debian/changelog ===
git-annex (5.20141125+deb8u1) jessie-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * CVE-2017-12976: git-annex before 6.20170818 allows remote attackers to
    execute arbitrary commands via an ssh URL with an initial dash
    character in the hostname, as demonstrated by an ssh://-eProxyCommand=
    URL (Closes: #873088)

 -- Antoine Beaupré <anarcat@debian.org>  Thu, 26 Oct 2017 10:23:02 -0400
