## git-annex 5.20141125+oops

=== standalone/android/Makefile ===
--- 
+++ 
@@ -147,7 +147,7 @@
 	# app, if it's also installed.
 	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && find -name .git -prune -o -type f -print0 | xargs -0 perl -pi -e 's/jackpal/ga/g'
 	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && perl -pi -e 's/Terminal Emulator/Git Annex/g' res/*/strings.xml
-	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && echo y | tools/update.sh
+	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && echo y | tools/update.sh || true
 	touch $@
 
 source: $(GIT_ANNEX_ANDROID_SOURCETREE)
