=== debian/control ===
--- 
+++ 
@@ -69,6 +69,7 @@
 	ikiwiki,
 	perlmagick,
 	git (>= 1:2.0),
+        quilt,
 	rsync,
 	wget,
 	curl,
